"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const axios_1 = __importDefault(require("axios"));
const index_1 = require("../../index");
function sendParent(data) {
    process.send && process.send(data);
}
async function Webhook(options, info) {
    if (!!options.url && options.url.length) {
        return new Promise(async (resolve, reject) => {
            await axios_1.default
                .post(options.url, info)
                .then(function (response) {
                resolve(response);
            })
                .catch((err) => {
                reject(err);
            });
        });
    }
}
(async () => {
    const args = process.argv.slice(2);
    const options = args[0];
    const objOptions = JSON.parse(options);
    const ev = await (0, index_1.initServer)(objOptions);
    let client;
    ev.on(index_1.onMode.interfaceChange, (change) => {
        Webhook(objOptions, change);
    });
    ev.on(index_1.onMode.qrcode, (qrcode) => {
        Webhook(objOptions, qrcode);
    });
    ev.on(index_1.onMode.newOnAck, (ack) => {
        Webhook(objOptions, ack);
    });
    ev.on(index_1.onMode.connection, async (conn) => {
        var _a;
        if (conn.erro) {
            if (conn.statusFind === 'browser' &&
                (conn.status === 'browserClosed' ||
                    conn.status === 'autoClose' ||
                    conn.status === 'noOpenWhatzapp' ||
                    conn.status === 'noOpenBrowser')) {
                sendParent({ delsession: true, session: objOptions.session });
                try {
                    if (!((_a = client === null || client === void 0 ? void 0 : client.page) === null || _a === void 0 ? void 0 : _a.isClosed())) {
                        client.page.close();
                        process.exit();
                    }
                }
                catch (_b) { }
            }
        }
        if (conn.connect) {
            client = conn.client;
            conn = { connect: true, session: objOptions.session };
            sendParent(conn);
        }
        Webhook(objOptions, conn);
    });
    process.on('message', async (response) => {
        Webhook(objOptions, response);
        if (response.type === 'sendText') {
            await client
                .sendMessage({
                to: response.to,
                body: response.body,
                options: {
                    type: 'sendText',
                },
            })
                .then((result) => {
                sendParent(Object.assign({ typeSend: 'sendText', result: true }, result));
            })
                .catch((error) => {
                sendParent(Object.assign({ typeSend: 'sendText', result: true }, error));
            });
        }
        if (response.type === 'sendFile') {
            await client
                .sendMessage({
                to: response.to,
                body: response.file_path,
                options: {
                    type: 'sendFile',
                    filename: response.file_name,
                },
            })
                .then((result) => {
                sendParent(Object.assign({ typeSend: 'sendFile', result: true }, result));
            })
                .catch((error) => {
                sendParent(Object.assign({ typeSend: 'sendFile', result: true }, error));
            });
        }
        if (response.type === 'sendAudio') {
            await client
                .sendMessage({
                to: response.to,
                body: response.url_mp3,
                options: {
                    type: 'sendAudio',
                },
            })
                .then((result) => {
                sendParent(Object.assign({ typeSend: 'sendAudio', result: true }, result));
            })
                .catch((error) => {
                sendParent(Object.assign({ typeSend: 'sendAudio', result: true }, error));
            });
        }
        if (response.type === 'sendImage') {
            await client
                .sendMessage({
                to: response.to,
                body: response.url_img,
                options: {
                    type: 'sendImage',
                },
            })
                .then((result) => {
                sendParent(Object.assign({ typeSend: 'sendImage', result: true }, result));
            })
                .catch((error) => {
                sendParent(Object.assign({ typeSend: 'sendImage', result: true }, error));
            });
        }
    });
})();
//# sourceMappingURL=hydra.js.map